package com.example.osnov_android

import android.util.Log
import androidx.compose.runtime.State
import androidx.compose.runtime.getValue
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.setValue
import androidx.lifecycle.ViewModel
import androidx.lifecycle.ViewModelProvider.Factory.Companion.from
import androidx.lifecycle.viewModelScope
import com.example.osnov_android.components.Constants
import com.example.osnov_android.models.Dishes
import com.example.osnov_android.models.DishesBlog
import com.example.osnov_android.models.UserState
import com.example.osnov_android.models.Users
import io.github.jan.supabase.auth.auth
import io.github.jan.supabase.auth.providers.builtin.Email
import io.github.jan.supabase.postgrest.from
import io.github.jan.supabase.postgrest.query.Columns
import kotlinx.coroutines.launch
import java.util.jar.Attributes.Name


class MainActivityViewModel : ViewModel() {
    private val _userState = mutableStateOf<UserState>(UserState.Loading)
    val userState: State<UserState> = _userState
    private val _users = mutableStateOf(listOf<Users>())
    val users: State<List<Users>> = _users

    private val _cookings = mutableStateOf(listOf<Dishes>())
    val cookings: State<List<Dishes>> = _cookings
    var cooking by mutableStateOf<Dishes?>(null)
    val dish by mutableStateOf<Dishes?>(null)
    private val _user = mutableStateOf(listOf<Users>())
    val user: State<List<Users>> = _user
    private val _cookingsblog = mutableStateOf(listOf<DishesBlog>())
    val cookingsblog: State<List<DishesBlog>> = _cookingsblog
    private var _iduserblog = mutableStateOf(listOf<DishesBlog>())
    val iduserblog: State<List<DishesBlog>> = _iduserblog
    val name = mutableStateOf("")

    fun SignIn(emailUser: String, userPassword: String) {
        viewModelScope.launch {
            try {
                Log.d("начало", "${emailUser} ${userPassword}")
                _userState.value = UserState.Loading
                Constants.supabase.auth.signInWith(Email) {
                    email = emailUser
                    password = userPassword
                }
                _users.value = Constants.supabase.from("Users").select {
                    filter {
                        Users::password eq Constants.supabase.auth.currentUserOrNull()!!.id
                    }
                }.decodeList()
                Log.d("Mytag", "${users.value.last().id_role}")
                Log.d("Конец", "закончили")
                _userState.value = UserState.Success("Signin is suc!")
            } catch (e: Exception) {
                _userState.value = UserState.Error("Error: ${e.message}")
            }
        }
    }

    fun SignUp(emailUser: String,nameUsers: String, gender: Int, passwordUsers: String) {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading
                Constants.supabase.auth.signUpWith(Email)
                {
                    email = emailUser
                    password = passwordUsers
                }
                Constants.supabase.from("Users").insert(
                    Users(
                        login = emailUser,
                        name = nameUsers,
                        password = Constants.supabase.auth.currentUserOrNull()!!.id,
                        id_role = 2,
                        id_gender = gender,
                        image = "https://unmeiceifhurzmiokboh.supabase.co/storage/v1/object/public/Users_ava/zaglushka.jpg"
                    )
                )
                Log.d("добавили", "Пользователь добавлен")
                _userState.value = UserState.Success("SignUp in suc!")
            } catch (e: Exception) {
                _userState.value = UserState.Error("Error: ${e.message}")
            }
        }
    }

    fun UpdateUser(nameUsers: String) {
        viewModelScope.launch {
            try {
            _userState.value = UserState.Loading
             Constants.supabase.from("Users").insert(
                Users(
                    login = "saddasd",
                    name = nameUsers,
                    password = Constants.supabase.auth.currentUserOrNull()!!.id,
                    id_role = 2,
                )
            )
            _userState.value = UserState.Success("SignUpUpdate in suc!")
            }
        catch (e: Exception) {
            _userState.value = UserState.Error("Error: ${e.message}")
        }
        }
    }

    fun DishesBlogUser()
    {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading

                _iduserblog.value = Constants.supabase.from("DishesBLog").select(columns = Columns.list("id_user")) {
                    filter {
                        eq("Name" , cookingsblog.value.last().Name)
                    }
                }.decodeSingleOrNull()!!

                name.value = Constants.supabase.from("Users").select()
                {
                    filter {

                    }

                }.decodeSingleOrNull()!!


        }
        catch (e: Exception)
        {
            _userState.value = UserState.Error(e.message!!)
        }
        }
    }

    fun allDishes() {
        viewModelScope.launch {
            try {
                Log.d("начали еда", "Поехали еда")
                _userState.value = UserState.Loading

                _cookings.value = Constants.supabase.from("Dishes").select().decodeList()

                _userState.value =
                    UserState.Success("select dishes suc!")
                Log.d("my_tag", "select dishes suc!")
            } catch (e: Exception) {
                _userState.value = UserState.Error("Error:  ${e.message}")
                Log.e("error", e.message!!)
            }
        }
    }

    fun allDishesBlog()
    {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading
                _cookingsblog.value = Constants.supabase.from("DishesBlog").select().decodeList<DishesBlog>()
                Log.d("blog_tag","Ехала еда блог")
                _userState.value = UserState.Success("Блог успешно выбран")
                Log.d("blog_tag", "данные с блога suc!")
            }
            catch (e: Exception)
            {
                _userState.value = UserState.Error(e.message!!)
            }

        }
    }

    fun UsersProfile()
    {
        viewModelScope.launch {
            _userState.value = UserState.Loading
            _users.value = Constants.supabase.from("Users").select {
                filter {
                    Users::password eq Constants.supabase.auth.currentUserOrNull()!!.id
                }
            }.decodeList()
        }
    }

    fun profileData() {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading
                _user.value = Constants.supabase.from("Users").select {
                    filter {
                        Users::password eq Constants.supabase.auth.currentUserOrNull()!!.id
                    }
                }.decodeList<Users>()
                Log.d("my_tag", "Профиль найден")
                _userState.value = UserState.Success("Профиль найден")

            } catch (e: Exception) {
                _userState.value = UserState.Error("Профиль не найден")
                Log.e("error", e.message!!)
            }
        }
    }

    fun updateUser(name: String, gender: Int) {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading
                Constants.supabase.from("Users").update(
                    {
                        Users::name setTo name
                        Users::id_gender setTo gender
                    }
                ) {
                    filter {
                        Users::password eq Constants.supabase.auth.currentUserOrNull()!!.id
                    }
                }
                Log.d("my_tag", "Данные обновлены")
                _userState.value = UserState.Success("Данные обновлены")

            } catch (e: Exception) {
                _userState.value = UserState.Error(e.message!!)
                Log.e("error", e.message!!)
            }
        }

    }

    fun giveCooking(cooking: Dishes) {
        this.cooking = cooking
    }

    fun deleteCooking(id: Int)
    {
        viewModelScope.launch {
            try {
                _userState.value = UserState.Loading

                Constants.supabase.from("Dishes").delete{
                    filter {
                        Dishes::id eq id
                    }
                }
                allDishes()
                _userState.value = UserState.Success("the dish has deleted suc!")
                Log.d("My tag dish", "deleted")
            }
            catch (e: Exception)
            {
                _userState.value = UserState.Error(e.message!!)
            }
        }
    }

}