package com.example.osnov_android.views.bottom_menu

import android.os.Build
import androidx.annotation.RequiresApi
import androidx.compose.runtime.Composable
import androidx.navigation.NavController
import androidx.navigation.NavHostController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import com.example.osnov_android.MainActivityViewModel
import com.example.osnov_android.navigation.Screen
import com.example.osnov_android.views.Blog
import com.example.osnov_android.views.Cookings
import com.example.osnov_android.views.Faq
import com.example.osnov_android.views.Profile

@RequiresApi(Build.VERSION_CODES.O)
@Composable
fun BottomGraph(viewModel: MainActivityViewModel, navController: NavHostController, mainNavController: NavController) {
    NavHost(navController = navController,
        startDestination = Screen.Profile.route,)
    {
        composable(Screen.Blog.route)
        {
            Blog(viewModel =viewModel)
        }
        composable(Screen.Cooking.route)
        {
            Cookings(viewModel, mainNavController )
        }
        composable(Screen.Faq.route)
        {
            Faq(viewModel )
        }
        composable(Screen.Profile.route)
        {
            Profile(viewModel, mainNavController )
        }
    }

}

