package com.example.osnov_android.views.bottom_menu

import com.example.osnov_android.R
import com.example.osnov_android.navigation.Screen

sealed class BottomMenuItem(
    val route: String,
    val title: String,
    val iconId: Int,
    val rote: String
) {
    object Blog: BottomMenuItem(
        route = "blog",
        title = "Blog",
        iconId = R.drawable.blog,
        rote = Screen.Blog.route
    )
    object Cooking: BottomMenuItem(
        route = "gotov",
        title = "Gotov",
        iconId = R.drawable.gotovka,
        rote = Screen.Cooking.route

    )
    object Faq: BottomMenuItem(
        route = "faq",
        title = "Faq",
        iconId = R.drawable.faq,
        rote = Screen.Faq.route
    )
    object Profile: BottomMenuItem(
        route = "profile",
        title = "Profile",
        iconId = R.drawable.profile,
        rote = Screen.Profile.route
    )
}