package com.example.osnov_android.views.bottommenuAdmin

import android.os.Build
import androidx.annotation.RequiresApi
import androidx.compose.runtime.Composable
import androidx.navigation.NavController
import androidx.navigation.NavHostController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import com.example.osnov_android.MainActivityViewModel
import com.example.osnov_android.navigation.Screen
import com.example.osnov_android.views.BlogAdmin
import com.example.osnov_android.views.CookingAdmin
import com.example.osnov_android.views.Faq
import com.example.osnov_android.views.Profile

@RequiresApi(Build.VERSION_CODES.O)
@Composable
fun BottomGraphAdmin(viewModel: MainActivityViewModel, navController: NavHostController, mainNavController: NavController) {
    NavHost(navController = navController,
        startDestination = Screen.Profile.route,)
    {
        composable(Screen.BlogAdmin.route)
        {
            BlogAdmin(viewModel, mainNavController)
        }
        composable(Screen.CookingAdmin.route)
        {
            CookingAdmin(viewModel, mainNavController )
        }
        composable(Screen.Faq.route)
        {
            Faq(viewModel )
        }
        composable(Screen.Profile.route)
        {
            Profile(viewModel, mainNavController )
        }
    }

}